//
//
// UEXEC Timer Task
//
//

#include "uart.h"
#include "uexec.h"
#include "timerTask.h"


unsigned char testTimerStack[200];
unsigned char testTimerMsgQ[100];

int testTimerTid;

void testTimer(void);
//
// main for test timerTask.c
//

int main(void)
{ 

   UART_Init();

   PPRINT("\r\n\r\n-------------------- testTimerTask is alive --------------------\r\n"); 
    
   *LED = (U8)~0xff;
   

   InitTimerTask();   


   testTimerTid = UEXC_CreateTask(
                     testTimer,                     // entry point
                     testTimerStack,                // stack ptr
                     sizeof(testTimerStack),        // stack size
                     testTimerMsgQ,                 // msgQ ptr
                     sizeof(testTimerMsgQ),         // msqQ size
                     (U16)UEXC_DEFAULT_TIME_SLICE,  // time slice mills
                     100);                          // task's priority

   
	UEXC_StartScheduler(); // won't return  

   PPRINT("\r\nmain still alive, can't happen");
	PPRINT("\r\nmain is finished");
   
   return 0;
}


//
// testTimer task
//
extern void testTimer(void)
{
   TimerReplyMsg_t tmoMsg;
   unsigned  char msgNum;
   unsigned  char xmtTid;
   unsigned  char i;
   unsigned  char msgSize;
   unsigned  char msgBuf[sizeof(TimerReplyMsg_t)];
   TimerId_t timerNum;          // timer id
   unsigned long seconds;
   unsigned int  mills;
   unsigned int  msgTmoMills;

   msgNum=0;
   while (1)
   {

     //
     // make a timer request
     //
     seconds = msgNum+1;
     mills   = 0;
      
     PPRINT("\r\n\r\ntestTimer making timer request for 0x");
     PPRINTU16(seconds); PPRINT(" seconds");

     tmoMsg.msgNum = msgNum+1;             // we get this back on timeout

     PPRINT(" ,tmoMsg.replyNum 0x");PPRINTU8(msgNum);
     PPRINT("\r\n ,tmoMsg.data 0x");

     for (i=1; i<=MAX_TIMER_REPLY_DATA; ++i)  // and this too
     {
        tmoMsg.data[i] = i;
        PPRINTU8(tmoMsg.data[i]); PPRINT(" "); 
     }


     if (StartTimer(seconds, mills ,testTimerTid, &tmoMsg, &timerNum) == 0)
     {
        PPRINT("\r\n\r\ntestTimer StartTimer failed");
        continue; //don't wait forever
     }


     //
     // wait for a timeout
     //
     PPRINT("\r\ntestTimer waiting for timeout msg");
     msgTmoMills = 8 *1000;
     if (UEXC_ReadMsg( msgBuf, 
                       sizeof(msgBuf), 
                       &xmtTid, 
                       &msgSize, 
                       msgTmoMills))
     {
        PPRINT("\r\ntestTimer got timeout msg of 0x"); PPRINTU8(msgSize);
        PPRINT(" bytes from task id 0x");     PPRINTU8(xmtTid);
        PPRINT("\r\n");
        for (i=0; i<msgSize; ++i)
        {
           PPRINT(" "); PPRINTU8(msgBuf[i]);
        }
     }
     else
     {
        PPRINT("\r\ntestTimer UEXC_ReadMsg timed out, calling KillTimer");
        if (KillTimer(timerNum) == 1)
           PPRINT("\r\ntestTimer KillTimer succedded");
        else
           PPRINT("\r\ntestTimer KillTimer succedded");
        
        msgNum = 0; // start over
     }
     ++msgNum;
   }
}

