
#ifndef __TIMER_TASK_H
#define __TIMER_TASK_H

#include "uexec.h"


#define TIMER_MILLS_PER_TICK  100
#define MAX_TIMER_REPLY_DATA  7
#define NUM_TIMER_TBL_ENTRIES 10
#define TIMER_TASK_PRIOR      50
//
//  timer reply message format, data sent to task requesting timer
//
typedef struct TimerReplyMsg_t
{
   unsigned char  msgNum;               // message number for reply
   unsigned char  data[MAX_TIMER_REPLY_DATA]; // timer reply data

}TimerReplyMsg_t;

//
// timer table entry format
//
typedef struct TimerEntry_t
{
   unsigned long     tmoTicks;                   // timer ticks left until timeout
   unsigned char     reqTid;                     // task requesting timer
   unsigned char     msgNum;                     // message number for reply
   unsigned char     data[MAX_TIMER_REPLY_DATA]; // timer reply data
} TimerEntry_t;

typedef unsigned char TimerId_t;        // timer id for kill request

//
// timer routines
//
extern unsigned char StartTimer(
                            unsigned long seconds,      // number of seconds to time
                            unsigned int  mills,        // number of milliseconds to time
                            unsigned char fromTid,      // uexec task id making request
                            TimerReplyMsg_t* replyMsg,  // reply message data sent on tmo
                            TimerId_t* timerNum);       // timer number, for killing timer

extern unsigned char KillTimer(TimerId_t timerId);      // timer number

extern void InitTimerTask(void);

extern void TimerTask(void);


#endif
